Module | ActionController::PolymorphicRoutes
In: | lib/action_controller/polymorphic_routes.rb

Polymorphic URL helpers are methods for smart resolution to a named route call when given an Active Record model instance. They are to be used in combination with ActionController::Resources.

These methods are useful when you want to generate correct URL or path to a RESTful resource without having to know the exact type of the record in question.

Nested resources and/or namespaces are also supported, as illustrated in the example:

      polymorphic_url([:admin, @article, @comment])

results in:

      admin_article_comment_url(@article, @comment)

## Usage within the framework

Polymorphic URL helpers are used in a number of places throughout the Rails framework:

- `url_for`, so you can use it with a record as the argument, e.g. `url_for(@article)`;
- ActionView::Helpers::FormHelper uses `polymorphic_path`, so you can write `form_for(@article)` without having to specify `:url` parameter for the form action;
- `redirect_to` (which, in fact, uses `url_for`) so you can write `redirect_to(post)` in your controllers;
- ActionView::Helpers::AtomFeedHelper, so you don‘t have to explicitly specify URLs for feed entries.

## Prefixed polymorphic helpers

In addition to `polymorphic_url` and `polymorphic_path` methods, a number of prefixed helpers are available as a shorthand to `:action => "…"` in options. Those are:

- `edit_polymorphic_url`, `edit_polymorphic_path`
- `new_polymorphic_url`, `new_polymorphic_path`
- `formatted_polymorphic_url`, `formatted_polymorphic_path`

Example usage:

      edit_polymorphic_path(@post)              # => "/posts/1/edit"
      formatted_polymorphic_path([@post, :pdf]) # => "/posts/1.pdf"

### Methods

polymorphic_path polymorphic_url

### Public Instance methods

polymorphic_path(record_or_hash_or_array, options = {})

Returns the path component of a URL for the given record. It uses `polymorphic_url` with `:routing_type => :path`.

polymorphic_url(record_or_hash_or_array, options = {})

Constructs a call to a named RESTful route for the given record and returns the resulting URL string. For example:

      # calls post_url(post)
      polymorphic_url(post) # => "http://example.com/posts/1"

#### Options

- `:action` - Specifies the action prefix for the named route: `:new`, `:edit`, or `:formatted`. Default is no prefix.
- `:routing_type` - Allowed values are `:path` or `:url`. Default is `:url`.

#### Examples

      # an Article record
      polymorphic_url(record)  # same as article_url(record)

      # a Comment record
      polymorphic_url(record)  # same as comment_url(record)

      # it recognizes new records and maps to the collection
      record = Comment.new
      polymorphic_url(record)  # same as comments_url()

[Validate]